import MouseTrap from 'mousetrap';

var hotkeysTooltip = {};

var addNewTooltipHelp = function addNewTooltipHelp(hotkey, showTooltipFunc) {
  if (!hotkeysTooltip[hotkey]) {
    hotkeysTooltip[hotkey] = [];
    MouseTrap.bind(hotkey, callHandlers(hotkey, true), 'keydown');
    MouseTrap.bind(hotkey, callHandlers(hotkey, false), 'keyup');
  }

  hotkeysTooltip[hotkey].push(showTooltipFunc);
};

var removeToolTipHelp = function removeToolTipHelp(hotkey, showTooltipFunc) {
  var index = hotkeysTooltip[hotkey].indexOf(showTooltipFunc);

  if (index > -1) {
    hotkeysTooltip[hotkey].splice(index, 1);
  }
};

var callHandlers = function callHandlers(hotkey, showTooltip) {
  return function () {
    var tooltips = hotkeysTooltip[hotkey];
    if (!tooltips) return console.error('No tooltip help define for that key');

    tooltips.forEach(function (func) {
      return func(showTooltip);
    });
  };
};

export { addNewTooltipHelp, removeToolTipHelp };