'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactProptypes = require('react-proptypes');

var _reactProptypes2 = _interopRequireDefault(_reactProptypes);

var _reactTippy = require('react-tippy');

var _mousetrap = require('mousetrap');

var _helpTooltipHandler = require('./helpTooltipHandler');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var HotkeyWrapper = (_temp2 = _class = function (_Component) {
  _inherits(HotkeyWrapper, _Component);

  function HotkeyWrapper() {
    var _temp, _this, _ret;

    _classCallCheck(this, HotkeyWrapper);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
      showTooltip: false
    }, _this.setShowTooltip = function (showTooltip) {
      return _this.state.showTooltip !== showTooltip && _this.setState({ showTooltip: showTooltip });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  HotkeyWrapper.prototype.componentDidMount = function componentDidMount() {
    if (!this.props.disableTooltip) {
      (0, _helpTooltipHandler.addNewTooltipHelp)(this.props.tooltipHotkey, this.setShowTooltip);
    }

    (0, _mousetrap.bind)(this.props.hotkey, this.props.onHotkeyPressed);
  };

  HotkeyWrapper.prototype.componentWillUnmount = function componentWillUnmount() {
    if (!this.props.disableTooltip) {
      (0, _helpTooltipHandler.removeToolTipHelp)(this.props.tooltipHotkey, this.setShowTooltip);
    }

    (0, _mousetrap.unbind)(this.props.hotkey);
  };

  HotkeyWrapper.prototype.render = function render() {
    var _props = this.props,
        children = _props.children,
        hotkey = _props.hotkey,
        tooltipProps = _props.tooltipProps,
        disableTooltip = _props.disableTooltip;
    var showTooltip = this.state.showTooltip;


    return disableTooltip ? children : _react2.default.createElement(
      _reactTippy.Tooltip,
      _extends({
        title: hotkey.toUpperCase(),
        open: showTooltip,
        trigger: 'manual',
        multiple: true
      }, tooltipProps),
      children
    );
  };

  return HotkeyWrapper;
}(_react.Component), _class.defaultProps = {
  tooltipHotkey: '?',
  tooltipProps: {
    position: 'bottom',
    arrow: true
  },
  disableTooltip: false
}, _temp2);
HotkeyWrapper.propTypes = process.env.NODE_ENV !== "production" ? {
  hotkey: _reactProptypes2.default.string.isRequired,
  onHotkeyPressed: _reactProptypes2.default.func.isRequired,
  children: _reactProptypes2.default.element.isRequired,
  tooltipHotkey: _reactProptypes2.default.string,
  tooltipProps: _reactProptypes2.default.object,
  disableTooltip: _reactProptypes2.default.bool
} : {};
exports.default = HotkeyWrapper;
module.exports = exports['default'];