'use strict';

exports.__esModule = true;
exports.removeToolTipHelp = exports.addNewTooltipHelp = undefined;

var _mousetrap = require('mousetrap');

var _mousetrap2 = _interopRequireDefault(_mousetrap);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var hotkeysTooltip = {};

var addNewTooltipHelp = function addNewTooltipHelp(hotkey, showTooltipFunc) {
  if (!hotkeysTooltip[hotkey]) {
    hotkeysTooltip[hotkey] = [];
    _mousetrap2.default.bind(hotkey, callHandlers(hotkey, true), 'keydown');
    _mousetrap2.default.bind(hotkey, callHandlers(hotkey, false), 'keyup');
  }

  hotkeysTooltip[hotkey].push(showTooltipFunc);
};

var removeToolTipHelp = function removeToolTipHelp(hotkey, showTooltipFunc) {
  var index = hotkeysTooltip[hotkey].indexOf(showTooltipFunc);

  if (index > -1) {
    hotkeysTooltip[hotkey].splice(index, 1);
  }
};

var callHandlers = function callHandlers(hotkey, showTooltip) {
  return function () {
    var tooltips = hotkeysTooltip[hotkey];
    if (!tooltips) return console.error('No tooltip help define for that key');

    tooltips.forEach(function (func) {
      return func(showTooltip);
    });
  };
};

exports.addNewTooltipHelp = addNewTooltipHelp;
exports.removeToolTipHelp = removeToolTipHelp;